#!/usr/bin/python

import math
import os
import sys

def inttobytes(num):
	ret = ""
	ret += chr(num & 0xff)
	ret += chr((num >> 8) & 0xff)
	ret += chr((num >> 16) & 0xff)
	ret += chr((num >> 24) & 0xff)
	return ret

if (len(sys.argv) != 2):
	print("Usage: rsccreate <directory of files>")
	print("You will need to have the directory in your current working directory")
	exit()
	
directory = sys.argv[1]

fileheaders = ""
filetable = ""

offset = 0
for filename in os.listdir(directory):
	fileh = open(os.getcwd() + "/" + directory + "/" + filename, "rb")
	filec = fileh.read()
	filelength = len(filec)
	filetable += filec
	fileh.close()

	#add header padding
	fileheaders += "\x48\x00\x65\x80"
	#add filename length
	fileheaders += inttobytes(len(filename))
	#add padded filename
	while(len(filename) % 4):
		filename += "\x00"
		
	fileheaders += filename
	#add padding
	fileheaders += "\x4a\x00\x66\x00"
	#add file offset
	fileheaders += inttobytes(offset)
	#add padding
	fileheaders += "\x4a\x00\x68\x00"
	#add file length
	fileheaders += inttobytes(filelength)
	#increment current offset by file length
	offset+= filelength

outfile = ""
#add initial header
outfile += "\x7B\x01\x0C\x00\x00\x00\x7F\xFF\xFF\xFF\x02\x00\x00\x00"
#add size of fileheaders + initial header size
outfile += inttobytes(len(fileheaders))
#add padding
outfile += "\x11\x00\x00\x00"
#add file headers
outfile += fileheaders
#add file table
outfile += filetable

#print(outfile)
fileh = open(directory + "_new.rsc", "wb+")
fileh.write(str(outfile))

